import { Component, EventEmitter, Input, OnDestroy, OnChanges, OnInit, Output, ApplicationRef } from '@angular/core';

@Component({
  selector: 'app-form',
  templateUrl: './form.component.html',
  styleUrls: ['./form.component.css']
})
export class FormComponent implements OnInit, OnChanges, OnDestroy {

  picArr = [];
  _item: any;
  KEY = 'hw_006';
  errs = [];

  // @Input()
  set item(item) {
    this._item = item;
    // this.init();

  }
  get item() {
    return this._item;
  }

  @Output()
  update = new EventEmitter();



  constructor(private appRef: ApplicationRef) {

  }


  ngOnInit() {

    this.item = {};
    this.item.contentObj = {};

    const getData = (<any>window).courseware.getData;
    getData((data) => {

      if (data) {
        this.item = data;
      } else {
        this.item = {};
      }

      if (!this.item.contentObj) {
        this.item.contentObj = {};
      }

      console.log('~data:', data);
      this.init();
      this.refresh();

    }, this.KEY);

    // this.initData();
  }
  ngOnChanges() {

  }

  ngOnDestroy() {
  }


  classItem() {
    function AniAssets() {
      this.ske = {};
      this.tex = {};
      this.png = {};
      this.setData = function (obj) {
        this.ske = obj.ske;
        this.tex = obj.tex;
        this.png = obj.png;
      }
    }

    function Item() {
      this.title = "";
      this.bgImg = "";
      this.wordAudio = "";
      this.imgAni = new AniAssets();
    }

    return new Item();
  }


  init() {
    //在卡片组之上需要增加 两个组 0根->picArr  1题组->testlet  2页面->page  3卡片对->itemData
    if (this.item.contentObj.picArr) {
      this.picArr = this.item.contentObj.picArr;
      this.check();
    } else {
      this.picArr = this.getDefaultPicArr();
      this.item.contentObj.picArr = this.picArr;
    }
    console.log('item:', this.item);
  }

  cardItemData() {
    return this.classItem()
  }

  getDefaultPicArr() {
    let arr = [this.classItem()]
    return arr;
  }

  initData() {


  }

  onDragonBoneSave(e, item) {
    console.log(e);
    this.save();
  }

  onImageUploadSuccessByItem(e, item) {
    item.bgImg = e.url;
    this.save();
  }

  onAudioUploadSuccessByItem(e, item) {
    item.wordAudio = e.url;
    this.save();
  }

  //添加一对
  addItem() {
    //最多4个 
    let item = this.cardItemData();
    this.picArr.push(item)
    this.saveItem();
  }
  deleteItem(i) {
    this.picArr.splice(i, 1);
    this.save();
  }





  //选择圆圈
  radioClick(it, radioValue) {
    it.radioValue = radioValue;
    this.saveItem();
  }


  saveItem() {

    console.log(' in saveItem');
    // this.update.emit(this.item);
    this.save();
  }

  check() {
    if (!this.picArr) return;
    this.errs.length = 0;
    // let picArr = this.picArr;
    // function tia(info) {
    //   let str = "";
    //   if (info.radioValue == "A") {
    //     if (!info.title) str += ",图片";
    //   } else if (info.radioValue == "B") {
    //     if (!info.pic_url) str += ",图片";
    //   } else if (info.radioValue == "C") {
    //     if (!info.audio_url) str += ",音频";
    //   } else {
    //     str += "卡片"
    //   }
    //   if (str) str += "未上传"
    //   return str;
    // }
    // for (let m = 0; m < picArr.length; m++) {
    //   for (let n = 0; n < picArr[m].length; n++) {
    //     if (picArr[m][n].length < 2) {
    //       this.errs.push(`星-${m + 1} 页-${n + 1} 卡片少于2个`);
    //     }
    //     for (let i = 0; i < picArr[m][n].length; i++) {
    //       let item = picArr[m][n][i];
    //       let left = item.left;
    //       let right = item.right;
    //       let code0 = tia(left);
    //       let code1 = tia(right);
    //       if (code0) this.errs.push(`星-${m + 1} 页-${n + 1} 第${i + 1}个卡片 左侧${code0}`);
    //       if (code1) this.errs.push(`星-${m + 1} 页-${n + 1} 第${i + 1}个卡片 右侧${code1}`);
    //     }
    //   }
    // }
    console.log("this.errs");
    console.log(this.errs);
    console.log("-------------------------");
  }


  save() {
    //触发一次检测
    this.check();
    (<any>window).courseware.setData(this.item, null, this.KEY);
    console.log('this.item = ' + JSON.stringify(this.item));
    this.refresh();
  }

  refresh() {
    setTimeout(() => {
      this.appRef.tick();
    }, 1);
  }
}

